class SiteController < ApplicationController
  layout 'hc'
  model :user, :election, :account

  def index
    @quickvotes = QuickVote.find_all(["quickvote = 1"]).sort {|a,b| b.enddate <=> a.enddate}[0..1]
    # if the person claims they are logged in
    if session[:user]

      # check to see that we actually have record of them
      if User.find_all(["id = ?", session[:user].id]).length == 1
        # if we have record of them, grab the list of their elections
        session[:user] = User.find(session[:user])
        @current_elections = session[:user].elections.sort do |a,b|
          b.enddate <=> a.enddate
        end
      else
        # if we have no record of them, set the session id back to
	# nothing and start again
        session[:user] = nil
      end
    end
  end

end
